/* -*-C++-*-
*******************************************************************************
*
* File:         test_filecopy.cc
* Description:  
*
*******************************************************************************
*/
/*
 * Copyright 2001 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <VrFileSink.h>
#include <VrFileSource.h>
#include <VrConnect.h>
#include <VrMultiTask.h>

const int Rate	= 8000;

int 
main (int argc, char **argv)
{
  // create the modules
  
  VrFileSource<char>* source = new VrFileSource<char>(Rate, "file_in.dat");
  VrFileSink<char>* sink = new VrFileSink<char>("file_out.dat");
  VrMultiTask *m = new VrMultiTask ();

  m->add (sink);

  NWO_CONNECT (source, sink);

  m->start ();
  while (1){
    m->process ();
  }
  m->stop ();

  return 0;
}
