/* -*- c++ -*- */
/*
 * Copyright 2002 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _QA_INTERLEAVER_FIFO_H_
#define _QA_INTERLEAVER_FIFO_H_

#include <cppunit/TestCase.h>
#include <cppunit/TestCaller.h>
#include <cppunit/TestSuite.h>
#include <cppunit/TextTestResult.h>

#include <interleaver_fifo.h>

class qa_interleaver_fifo : public CppUnit::TestCase {
 private:
  interleaver_fifo<int>	*fifo;
  
 public:

  void tearDown (){
    delete fifo;
    fifo = 0;
  }

  static void register_tests (CppUnit::TestSuite *suite)
  {
    suite->addTest (new CppUnit::TestCaller<qa_interleaver_fifo>
		    ("fifo: t0", &qa_interleaver_fifo::t0));

    suite->addTest (new CppUnit::TestCaller<qa_interleaver_fifo>
		    ("fifo: t1", &qa_interleaver_fifo::t1));

    suite->addTest (new CppUnit::TestCaller<qa_interleaver_fifo>
		    ("fifo: t2", &qa_interleaver_fifo::t2));
  }

 private:

  void t0 ();
  void t1 ();
  void t2 ();

};


#endif /* _QA_INTERLEAVER_FIFO_H_ */
