/* -*- c++ -*- */
/*
 * Copyright 2003 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _GRSERIALTOPARALLEL_H_
#define _GRSERIALTOPARALLEL_H_

#include <VrSigProc.h>


class GrSerialToParallel : public VrSigProc {
  int	d_item_size;
  int	d_items_per_block;
  
 public:
  GrSerialToParallel (int item_size, int items_per_block);
  ~GrSerialToParallel ();

  virtual const char *name () { return "GrSerialToParallel"; }

  virtual void pre_initialize ();
  virtual int forecast (VrSampleRange output, VrSampleRange inputs[]); 
  virtual int work (VrSampleRange output, void *o[], VrSampleRange inputs[], void *i[]);
};

#endif
