/* -*- Mode: c++ -*- */
/*
 * Copyright 2001,2003 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
/*
 *  Copyright 1997 Massachusetts Institute of Technology
 * 
 *  Permission to use, copy, modify, distribute, and sell this software and its
 *  documentation for any purpose is hereby granted without fee, provided that
 *  the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of M.I.T. not be used in advertising or
 *  publicity pertaining to distribution of the software without specific,
 *  written prior permission.  M.I.T. makes no representations about the
 *  suitability of this software for any purpose.  It is provided "as is"
 *  without express or implied warranty.
 * 
 */

/*
 * Look Ma! No templates!
 */

#ifndef _GRSINK_H_
#define _GRSINK_H_

#include <VrSigProc.h>
#include <stddef.h>		// size_t

class GrSink : public VrSigProc {
private:
  unsigned int d_optimalSize;

public: 
  GrSink (size_t sizeof_iType);

  virtual const char *name() { return "GrSink"; }

  // standard "work" routine.  We have it call work3, which
  // doesn't pass unnecessary output pointers.
  
  virtual int work(VrSampleRange output, void *o[],
		   VrSampleRange inputs[], void *i[]) {
    return work3 (output, inputs, i);
  };

  virtual int work3(VrSampleRange output, 
		    VrSampleRange inputs[], void *i[]) = 0; 


  // FIXME does anyone actually use this?
  //  set this if you want the sink to use smaller chunks
  //  than the maxLatency would dictate
  void setOptimalSize (unsigned int s);

  // internal routines
  virtual void setup();
  void setup_upstream(); 
};

#endif // _GRSINK_H_

