/* -*-C-*-
*******************************************************************************
*
* File:         GrTestSkippingSink.h
* Description:  
*
*******************************************************************************
*/

/*
 * Copyright 2001 Free Software Foundation, Inc.
 * 
 * This file is part of GNU Radio
 * 
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _GRTESTSKIPPINGSINK_H_
#define _GRTESTSKIPPINGSINK_H_

#include <VrSink.h>


class GrTestSkippingSink : public VrSink<unsigned long> {
 private:
  bool		sync_mode_p;
  VrSampleIndex	last;

 public:
  virtual const char *name() { return "GrTestSkippingSink"; }

  virtual int work3 (VrSampleRange output,
		     VrSampleRange inputs[], void *i[]);

  virtual int forecast(VrSampleRange output, VrSampleRange inputs[]); 

  GrTestSkippingSink (bool use_sync_mode);
};


#endif /* _GRTESTSKIPPINGSINK_H_ */
